//
// php-armadillo/interfaces.cc
//
// @Author CismonX
//

#include "php_arma.hh"
#include "interfaces.hh"

#define N_INT "Internal\\"

namespace php_arma
{
    void internal_interfaces_init()
    {
        common_ce           = interface_register(N_INT "Common");

        vector_ce           = interface_register(N_INT "Vector");
        matrix_ce           = interface_register(N_INT "Matrix");

        dense_ce            = interface_register(N_INT "Dense", common_ce);
        sparse_ce           = interface_register(N_INT "Sparse", common_ce);
        dense_vector_ce     = interface_register(N_INT "DenseVector", vector_ce, dense_ce);

        resizable_ce        = interface_register(N_INT "Resizable");
        resizable_vector_ce = interface_register(N_INT "ResizableVector", resizable_ce);
        resizable_matrix_ce = interface_register(N_INT "ResizableMatrix", resizable_ce);

        subview_ce          = interface_register(N_INT "Subview");
        diagonal_ce         = interface_register(N_INT "Diagonal", subview_ce);
        scalar_ce           = interface_register(N_INT "Scalar", subview_ce);
    }

    zend_class_entry         *common_ce;
    zend_class_entry         *vector_ce, *matrix_ce;
    zend_class_entry         *dense_ce, *sparse_ce;
    zend_class_entry         *dense_vector_ce;
    zend_class_entry         *resizable_ce;
    zend_class_entry         *resizable_vector_ce, *resizable_matrix_ce;
    zend_class_entry         *subview_ce;
    zend_class_entry         *diagonal_ce;
    zend_class_entry         *scalar_ce;
}
