<?php

namespace Arma;

abstract class Fill
{
    /**
     * Do not modify the elements.
     */
    const NONE = 0;

    /**
     * Set all elements to 0.
     */
    const ZEROS = 1;

    /**
     * Set all elements to 1.
     */
    const ONES = 2;

    /**
     * Set the elements along the main diagonal to 1 and off-diagonal elements to 0.
     */
    const EYE = 3;

    /**
     * Set each element to a random value from a uniform distribution in the [0,1] interval.
     */
    const RANDU = 4;

    /**
     * Set each element to a random value from a normal/Gaussian distribution with zero mean and unit variance.
     */
    const RANDN = 5;
}
