<?php

namespace Arma\Internal;

/**
 * Interface for vectors with a Dense Layout (Row and Col)
 * @package Arma\Internal
 */
interface DenseVector extends Dense, Vector
{
    // Initialization

    /**
     * Set all the elements of an object to one, optionally first changing the size to specified dimensions.
     *
     * @param int $n_elem[optional]
     * @return void
     */
    function ones($n_elem);

    /**
     * Set all the elements to random values, optionally first changing the size to specified dimensions.
     *
     * Uses a uniform distribution in the [0,1] interval.
     *
     * @param int $n_elem[optional]
     * @return void
     */
    function randu($n_elem);

    /**
     * Set all the elements to random values, optionally first changing the size to specified dimensions.
     *
     * Uses a normal/Gaussian distribution with zero mean and unit variance.
     *
     * @param int $n_elem[optional]
     * @return void
     */
    function randn($n_elem);
}
