<?php

namespace Arma\Internal;

/**
 * Interface for diagonal subview of matrix (Mat and SpMat).
 *
 * @package Arma\Internal
 */
interface Diagonal extends Common, Subview
{
    /**
     * Sets the elements to a specified value. The type of value must match the type of elements used by
     * the container object.
     *
     *
     * @param number|\Arma\Complex $value
     * @return void
     */
    function fill($value);

    /**
     * Set the elements of an object to zero.
     *
     * @return void
     */
    function zeros();

    /**
     * Set all the elements of an object to one.
     *
     * @return void
     */
    function ones();

    /**
     * Set all the elements to random values.
     *
     * Uses a uniform distribution in the [0,1] interval.
     *
     * @return void
     */
    function randu();

    /**
     * Set all the elements to random values.
     *
     * Uses a normal/Gaussian distribution with zero mean and unit variance.
     *
     * @return void
     */
    function randn();
}
