<?php

namespace Arma\Internal;

/**
 * Interface for resizable objects (non-subview objects)
 *
 * @package Arma\Internal
 */
interface Resizable
{
    /**
     * Set the size to be the same as the given object.
     *
     * The given object must be of the same root type as the calling object.
     *
     * @param static $other
     * @return void
     */
    function copySize($other);

    /**
     * Reset the size to zero. The object will have no elements.
     *
     * @return void
     */
    function reset();
}
