<?php

namespace Arma\Internal;

/**
 * Interface for resizable matrices.
 *
 * @package Arma\Internal
 */
interface ResizableMatrix extends Resizable
{
    /**
     * Recreate the object according to given size specifications, with the elements taken from the
     * previous version of the object in a column-wise manner.
     *
     * The elements in the generated object are placed column-wise.
     *
     * @param int $n_rows
     * @param int $n_cols
     * @return void
     */
    function reshape($n_rows, $n_cols);

    /**
     * Recreate the object according to given size specifications, while preserving the elements
     * as well as the layout of the elements.
     *
     * @param int $n_rows
     * @param int $n_cols
     * @return void
     */
    function resize($n_rows, $n_cols);

    /**
     * Change the size of an object, without explicitly preserving data and without initialising the elements.
     *
     * @param int $n_rows
     * @param int $n_cols
     * @return void
     */
    function setSize($n_rows, $n_cols);
}
