<?php

namespace Arma\Internal;

/**
 * Interface for resizable vectors.
 *
 * @package Arma\Internal
 */
interface ResizableVector extends Resizable
{
    /**
     * Recreate the object according to given size specifications, while preserving the elements
     * as well as the layout of the elements.
     *
     * @param int $n_elem
     * @return void
     */
    function resize($n_elem);

    /**
     * Change the size of an object, without explicitly preserving data and without initialising the elements.
     *
     * @param int $n_elem
     * @return void
     */
    function setSize($n_elem);
}