<?php

namespace Arma\Internal;

/**
 * Interface for subviews which wraps a single scalar value.
 *
 * @package Arma\Internal
 */
interface Scalar extends Subview
{
    /**
     * Return a copy of the representing scalar value of this object.
     *
     * @return number|\Arma\Complex
     */
    function val();

    /**
     * Set the representing value to the specified new value.
     *
     * @param number|\Arma\Complex $value
     * @return void
     */
    function setTo($value);
}
