<?php

namespace Arma\Internal;

/**
 * Interface for objects whose elements are stored in CSC format (SpMat, SpCol and SpRow).
 *
 * @package Arma\Internal
 */
interface Sparse extends Common
{
    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return \Arma\SpSvVal
     */
    function at($i, $j);

    /**
     * {@inheritdoc}
     *
     * @param int $i
     * @param int $j[optional]
     * @return \Arma\SpSvVal
     */
    function __invoke($i, $j);
}
